`timescale 1ns/1ps
module tb();
reg SYM_CLK=0;
reg KEY1=0;
reg SW1=0;
wire img_done;
wire		outvalid;
wire [7:0]	dout;

always #5 SYM_CLK=~SYM_CLK;
initial begin
#10 KEY1=1;
#10 SW1=1;
end

mjpeg_exp mjpeg_exp(
.SYM_CLK (SYM_CLK),
.KEY1    (KEY1),
.SW1     (SW1),
.img_done   (img_done),
.outvalid (outvalid),
.dout (dout)
);
//**********************************************************************
// --- Write file
//**********************************************************************
integer file_out;
initial begin
      file_out = $fopen("default.jpg", "wb");
if (!file_out)
        begin
          $display("Could not open output file");
          $finish;
end
end 

always @ (posedge SYM_CLK )
    begin
      if (outvalid)
        $fwriteb(file_out, "%c", dout);     
    end

//**********************************************************************
// --- Check Sum
//**********************************************************************
reg [31:0] check_sum;

always @ (posedge SYM_CLK or negedge SW1)begin
    if (!SW1)
        check_sum<=0;
    else if (img_done)
        check_sum<=0;
    else  if (outvalid)
        check_sum<=check_sum^dout;     
    end

initial begin
    $fsdbDumpfile("verilog.fsdb");
    $fsdbDumpvars;
end
initial begin
    #5_000_000;
    $finish;
end

endmodule
